/****************************************
 *
 *   INSERT-PROJECT-NAME-HERE - INSERT-GENERIC-NAME-HERE
 *   Copyright (C) 2020 Victor Tran
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * *************************************/
#ifndef COMMON_H
#define COMMON_H

#include <QStringList>

namespace Common {
    /**
     * Given a list of items, find the correct index to insert this item into
     *
     * @param preferredOrder   The preferred order of items
     * @param currentItems     The items that are currently in the layout
     * @param item             The name of the current item
     * @return                 An index, or -1 to add to the end of the layout
     */
    int getInsertionIndex(QStringList preferredOrder, QStringList currentItems, QString item);
}

#endif // COMMON_H
