/****************************************
 *
 *   INSERT-PROJECT-NAME-HERE - INSERT-GENERIC-NAME-HERE
 *   Copyright (C) 2021 Victor Tran
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * *************************************/
#ifndef GATEWAYSEARCHPROVIDER_H
#define GATEWAYSEARCHPROVIDER_H

#include <QObject>
#include <QStyleOptionViewItem>
#include <tpromise.h>

class GatewaySearchProvider : public QObject {
        Q_OBJECT
    public:
        explicit GatewaySearchProvider(QObject* parent = nullptr);
        ~GatewaySearchProvider();

        virtual tPromise<QList<QVariantMap>>* searchResults(QString query) = 0;
        virtual void launch(QVariantMap data) = 0;

        virtual void paint(QPainter* painter, const QStyleOptionViewItem& option, const QVariantMap data) const = 0;
        virtual QSize sizeHint(const QStyleOptionViewItem& option, const QVariantMap data) const = 0;

    signals:

};

#endif // GATEWAYSEARCHPROVIDER_H
